package com.qizhen.healsphere.common.ai;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpUtil;
import cn.hutool.http.Method;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class QizhenAssistant {

    public static String noAnswer = "未找到相关知识";
    public static Map<String,String> getChatResponse(String userInput, String conversationId,String appId) {
        int retry = 0;
        try {
           return getAnswer(userInput, conversationId,appId);
        }catch(Exception e){
            e.printStackTrace();
            retry++;
            if(retry>=2){
                Map<String,String> map = new HashMap<>();
                map.put("answer","failed");
                return map;
            }
            return getAnswer(userInput, conversationId,appId);
        }
    }
    public static final String domain = "https://console.bce.baidu.com/ai_apaas/personalSpace/knowledgeBase/document/detail/";

    private static boolean contants(String content, String regex){
        // 编译正则表达式
        Pattern pattern = Pattern.compile(regex);

        // 创建matcher对象
        Matcher matcher = pattern.matcher(content);
        return matcher.find();
    }

    private static Map<String,String> getAnswer(String userInput, String conversationId,String appId) {
        Map<String,String> map = new HashMap<>();
        JSONObject json = new JSONObject();
        json.put("app_id", appId);
        json.put("conversation_id", conversationId);
        json.put("query", userInput);
        json.put("stream", false);

        HttpRequest request = HttpUtil.createRequest(Method.POST, "https://qianfan.baidubce.com/v2/app/conversation/runs")
                .header("X-Appbuilder-Authorization", "Bearer bce-v3/ALTAK-MyGbNEA18oT3boS2nOga1/d8b5057f7842f59b2c64971d8d077fe724d0aed5")
                .header("Content-Type", "application/json")
                .body(json.toJSONString()).timeout(60*1000);
        ;
        long l = System.currentTimeMillis();
        String resposne = request.execute().body();
        String answer = JSONObject.parseObject(resposne).getString("answer");
        if(answer.contains(noAnswer)){
            map.put("answer",noAnswer);
            return map;
        }
        map.put("answer",answer == null ? noAnswer : answer);
        JSONArray contents = JSONObject.parseObject(resposne).getJSONArray("content");
        JSONArray docs = new JSONArray();
        List<String> defaultReferences = new ArrayList<>();
        for(int i=0;i<contents.size();i++){
            JSONObject content = contents.getJSONObject(i);
            if("rag".equals(content.getString("content_type"))){
                JSONObject outputs = content.getJSONObject("outputs");
                if(outputs!=null) {
                    JSONArray references = outputs.getJSONArray("references");
                    if (references != null && references.size() > 0) {
                        for (int j = 0; j < references.size(); j++) {
                            JSONObject reference = new JSONObject();
                            String id = references.getJSONObject(j).getString("id");
                            if(!contants(answer,"\\^(\\[\\d+\\])*\\["+id+"\\](\\[\\d+\\])*\\^")){
                                continue;
                            }
                            reference.put("index", id);
                            //reference.put("url", domain + references.getJSONObject(j).getString("knowledgebase_id") + "/" + references.getJSONObject(j).getString("document_id"));
                            reference.put("content", references.getJSONObject(j).getString("content"));
                            String title = references.getJSONObject(j).getString("title");
                            reference.put("title", title);
                            //reference.put("chunk_id", references.getJSONObject(j).getString("chunk_id"));
                            docs.add(reference);
                            defaultReferences.add(title);
                        }
                    }
                }
            }
        }
        if(docs==null || docs.size()==0){
            map.put("answer",noAnswer);
            return map;
        }
        map.put("references", docs.toJSONString());
        map.put("defaultReferences", JSON.toJSONString(defaultReferences));
        System.out.println((System.currentTimeMillis() - l) / 1000 + userInput);
        return map;
    }
    public static String getConversationId(String appId) {
        JSONObject json = new JSONObject();
        json.put("app_id", appId);
        //json.put("app_id", "454b1634-91ad-4dde-9d2f-f9a3302fdcbe");
        HttpRequest request = HttpUtil.createRequest(Method.POST, "https://qianfan.baidubce.com/v2/app/conversation")
                .header("X-Appbuilder-Authorization", "Bearer bce-v3/ALTAK-MyGbNEA18oT3boS2nOga1/d8b5057f7842f59b2c64971d8d077fe724d0aed5")
                .header("Content-Type", "application/json")
                .body(json.toJSONString());
        ;
        String resposne = request.execute().body();
        return JSONObject.parseObject(resposne).getString("conversation_id");
    }

}
